#if defined(SELECTION) || defined(USER_COLOR)
uniform vec4 u_color;
#endif

#ifdef BLACKWHITE
  const float rFactor = 0.2989;
  const float gFactor = 0.5870;
  const float bFactor = 0.1140;
#endif

void main()
{ 
  vec4 final_color = vec4(0.0, 0.0, 0.0, 1.0);
  
  ///////////////////////////////////////////////////////////////
  // Vertex color blending
  ///////////////////////////////////////////////////////////////     
  // vec4 vertex_color = 
  // Not implemented yet
  
  ///////////////////////////////////////////////////////////////
  // Texture sampling
  ///////////////////////////////////////////////////////////////
  #ifdef SAMPLE_TEXSLOT_0
    vec4 texture_color0 = SampleTextureSlot0();
  #endif
  
  #ifdef SAMPLE_TEXSLOT_1
    vec4 texture_color1 = SampleTextureSlot1();
  #endif

  #ifdef SAMPLE_TEXSLOT_2
    vec4 texture_color2 = SampleTextureSlot2();
  #endif

  #ifdef SAMPLE_TEXSLOT_3
    vec4 texture_color3 = SampleTextureSlot3();
  #endif
  
  ///////////////////////////////////////////////////////////////
  // Texture vertex blending
  ///////////////////////////////////////////////////////////////
  // Texture vertex blending uses color set 0  
  #if defined(VERTEX_BLEND)
    #if defined(SAMPLE_TEXSLOT_0) && defined(SAMPLE_TEXSLOT_1) && defined(SAMPLE_TEXSLOT_2) && defined(SAMPLE_TEXSLOT_3)
      final_color  = VertexColorBlend(texture_color0, texture_color1, texture_color2, texture_color3, v_color0);
    #elif defined(SAMPLE_TEXSLOT_0) && defined(SAMPLE_TEXSLOT_1) && defined(SAMPLE_TEXSLOT_2)
      final_color  = VertexColorBlend(texture_color0, texture_color1, texture_color2, v_color0);
    #elif defined(SAMPLE_TEXSLOT_0) && defined(SAMPLE_TEXSLOT_1)  
      final_color  = VertexColorBlend(texture_color0, texture_color1, v_color0);
    #endif
  #else
    // Default behavior
    #if defined(SAMPLE_TEXSLOT_0)
      final_color = texture_color0;
    #elif defined(INPUT_COLOR0)
      final_color = v_color0;
    #else
      final_color = vec4(0.0, 0.0, 0.0, 1.0);
    #endif
  #endif
    
  ///////////////////////////////////////////////////////////////
  // Texture color blending
  ///////////////////////////////////////////////////////////////
  // Not implemented yet

  ///////////////////////////////////////////////////////////////
  // Vertex - User - Texture color operations
  ///////////////////////////////////////////////////////////////
  #ifdef ADD_VERTEX_COLOR
    final_color += v_color0;
  #endif
  
  #ifdef MUL_VERTEX_COLOR
    final_color *= v_color0;
  #endif
  
  #ifdef VERTEX_MUL_ALPHA 
    final_color.rgb *= color.a;
  #endif
  
  #ifdef VERTEX_REPLACE_ALPHA 
    final_color.a = v_color0.a;
  #endif
  
  ///////////////////////////////////////////////////////////////
  // Convert to black and white 
  ///////////////////////////////////////////////////////////////
  #ifdef BLACKWHITE  
    final_color = ConvertToBW(final_color);
  #endif
  
  ///////////////////////////////////////////////////////////////
  // Manually set final fragment color
  ///////////////////////////////////////////////////////////////
  #ifdef USER_COLOR
    final_color = u_color;
  #endif
  
  ///////////////////////////////////////////////////////////////
  // Selection highlighting
  ///////////////////////////////////////////////////////////////  
  #ifdef SELECTION
    final_color.rgb = InterpolateLinearRGB(white_color, final_color, u_color.x);
  #endif
    
  gl_FragColor = final_color;
}