#include "FragmentFormatDefine.shader"

varying float rel_height;
uniform int u_shadow;

const vec4 pink             = vec4(0.8906, 0.7148, 0.9531, 1.0);
const lowp vec4 out_color   = vec4(0.105, 0.324, 0.047, 0.6);

#ifdef SHADER_OPTION_SEPARATE_ALPHA
  #ifdef SHADER_OPTION_TEXSLOT_0
    uniform sampler2D s_texture0;
    uniform sampler2D s_texture1;
  #endif
#else
  #ifdef SHADER_OPTION_TEXSLOT_0
    uniform sampler2D s_texture0;
  #endif
#endif  


void main()
{
  #if defined(SHADER_OPTION_TEXSLOT_0) || defined(VERTEX_SHADER_OUTPUT_UV0)
    vec4 color = SampleTextureSlot0();
  #elif defined(VERTEX_SHADER_OUTPUT_COLOR0)  
    vec4 color = v_color0;
  #else
    #error "Uv or color must be defined"
  #endif
  
  if(u_shadow == 1)
  {    
    vec4 shadow_color   = vec4(out_color.xyz, out_color.a * smoothstep( 0.47, 0.53, tex_clr.a ));   
    shadow_color.rgb    = rel_height * pink.rgb + (1.0 - rel_height) * shadow_color.rgb;  
    gl_FragColor        = shadow_color;
  }
  else
  {  
    if(tex_clr.a < 0.1)
    {
      discard;
    }
    
    tex_clr.rgb   = rel_height * pink.rgb + (1.0 - rel_height) * tex_clr.rgb;  
    gl_FragColor  = tex_clr;
  }
}