precision lowp float;

const vec4 top_clr        = vec4(1.0, 0.408, 0.64, 1.0);
const vec4 bottom_clr     = vec4(0.97, 0.34, 0.67, 1.0);
const float fade_end      = 75.0;

varying float vtx_height_w;
varying vec2  v_uv0;

uniform sampler2D s_texture0;
uniform sampler2D s_texture1;

void main()
{
  // Sample texture, but we we only need alpha
  vec4 tex_clr      = texture2D(s_texture0, v_uv0);      
  vec4 tex_alpha    = texture2D(s_texture1, v_uv0);      
  
  // Relative height of vertex based on curve defined in vertex shader
  float rel_height  = clamp( vtx_height_w / fade_end, 0.0, 1.0);  
  
  // Linear blend with rel_height as factor
  vec4 bubble_clr   = rel_height * top_clr + (1.0 - rel_height) * bottom_clr; 
  gl_FragColor      = vec4(bubble_clr.xyz, tex_alpha.x);
}