precision lowp float;
varying vec2 v_uv0;

const float rFactor = 0.2989;
const float gFactor = 0.5870;
const float bFactor = 0.1140;

uniform sampler2D s_texture0;
uniform sampler2D s_texture1;

void main()
{
  vec4 tex_clr    = texture2D(s_texture0, v_uv0); 
  vec4 tex_alpha  = texture2D(s_texture1, v_uv0); 
  
  float val       = tex_clr.r * rFactor + tex_clr.g * gFactor + tex_clr.b * bFactor;
  gl_FragColor    = vec4(val, val, val, tex_alpha.x);
}