uniform mat4  u_m;
uniform mat4  u_vp;
uniform float u_outline_factor;
uniform vec4  u_camera;

attribute vec4 a_position;
attribute vec4 a_normal;
attribute vec2 a_uv;

varying vec4 v_normal;
varying vec2 v_uv;

precision lowp float;

void main()
{		
  vec4 position = a_position * u_m;

	vec4 normal   = a_normal;
  normal.w      = 0.0;
  normal        = normal * u_m;
  normal.xyz    = normalize(normal.xyz);
  
  vec4 toCamera   = vec4((u_camera - position).xyz, 0.0);
  float len       = clamp(length(toCamera), 1500.0, 13000.0);
  
  position    = position + normal * (len * 0.0003);
  position    = position * u_vp;
  gl_Position = position;
}
	
