precision lowp float;
varying vec2 v_uv0;

uniform sampler2D s_texture0;
uniform sampler2D s_texture1;
uniform vec4      u_color;

const vec4 white_color = vec4(1.0, 1.0, 1.0, 1.0);

void main()
{
  vec4 tex_clr    = texture2D(s_texture0, v_uv0);
  vec4 tex_alpha  = texture2D(s_texture1, v_uv0).rrrr;
  
  vec4  clr     = white_color * u_color.x + (1.0 - u_color.x) * tex_clr;
  gl_FragColor  = vec4(clr.r, clr.g, clr.b, tex_alpha.r);
}