precision lowp float;

varying vec4 v_color0;
varying vec2 v_uv0;

uniform sampler2D s_texture0;

// Gamma parameters
const float gamma           = 2.2;
const float gamma_inv       = 1.0 / gamma;
const vec3  gamma_vec       = vec3(gamma, gamma, gamma);
const vec3  gamma_inv_vec   = vec3(gamma_inv, gamma_inv, gamma_inv);

void main()
{
  vec4 tex_color0 = texture2D(s_texture0, v_uv0);

  // Optimization note: 
  // -storing in linear space direcly would eliminate this step
  // -instead of using pow at the end, we can encode the function result inside a 1D texture
    
  vec4 result = tex_color0;

  // Convert to sRGB space
  result.rgb = pow(result.rgb, gamma_inv_vec);
  gl_FragColor = result;
}