precision highp float;

varying vec4 v_color_add;
varying vec2 v_uv0;

uniform sampler2D s_texture0;

// Gamma parameters
const float gamma_inv     = 1.0 / 2.2;
const vec3  gamma_inv_vec = vec3(gamma_inv, gamma_inv, gamma_inv);

void main()
{  
  vec4 result  = texture2D(s_texture0, v_uv0);  
  result      += v_color_add;                       
                       
  // Convert to sRGB space
  result.rgb   = pow(result.rgb, gamma_inv_vec);
  gl_FragColor = result;
}