uniform mat4  u_mvp;
uniform float u_time;

attribute vec4 a_position;
attribute vec4 a_color0;
attribute vec2 a_uv0;

varying vec2 v_uv0;

const float c_freq      = 5.0;
const float c_amplitude = 0.2;
const float c_2PI       = 6.28318;

void main()
{
  vec3 wobblePos  = a_position.xyz;
  float distance  = length(wobblePos.xz);
  
  wobblePos.y += c_amplitude * sin(c_2PI * u_time * c_freq + distance) * a_color0.w;
  
  gl_Position = vec4(wobblePos, 1.0) * u_mvp;
  v_uv0       = a_uv0;
}  