uniform mat4  u_mvp;
uniform float u_time;
uniform float u_freq;
uniform float u_amplitude;

attribute vec4 a_position;
attribute vec4 a_color0;
attribute vec2 a_uv0;

varying vec2 v_uv0;

//const float c_freq      = 10.0;
//const float c_amplitude = 0.5;
const float c_2PI       = 6.28318;

void main()
{
  vec3 wobblePos  = a_position.xyz;
  float distance  = length(wobblePos.xz);
  
  wobblePos.y += u_amplitude * sin(c_2PI * u_time * u_freq + distance) * a_color0.w;
  
  gl_Position = vec4(wobblePos, 1.0) * u_mvp;
  v_uv0       = a_uv0;
}