uniform mat4 u_mvp;
uniform mat4 u_m;
attribute vec4 a_position;
attribute vec2 a_uv0;

varying vec2 v_uv0;
varying vec4 v_color_add;

const float modifier = 0.3;
const vec4 color_add = vec4(0.710, 0.533, 0.036, 0.0);


void main()
{
  vec4 worldPos = a_position * u_m;
  worldPos.y    = 0.0;
  
  float factor  = modifier  * clamp(1.0 - length(worldPos.xyz) / 1700.0, 0.0, 1.0);
  v_color_add   = color_add * factor;
  
  
  gl_Position = a_position * u_mvp;
  v_uv0       = a_uv0;
}