uniform mat4 u_mvp;
uniform mat4  u_m;
uniform float u_time;

attribute vec4 a_position;
attribute vec2 a_uv0;

const float c_stripemul   = 20.0;
const float c_stripoffset = 0.0;
const float c_half        = 0.5;
const mat2  c_rot         = mat2( 0.707168, -0.707168, 0.707168, 0.707168);

varying vec2  v_uv0;
varying vec2  v_uv1;
varying float v_lerpfac;

void main()
{
  gl_Position = a_position * u_mvp;
  
  v_uv0 = ((a_position * u_m).xy + 1900.0) / 3800.0;  
  v_uv0 *= c_stripemul;
  v_uv1 = v_uv0 + c_stripoffset;     
  v_lerpfac = sin(u_time) * 0.5 + 0.5;
     
  v_uv0 = c_rot * v_uv0;
  v_uv1 = c_rot * v_uv1;
}