uniform mat4  u_mvp;
uniform mat4  u_m;
uniform vec4  u_foam_pos[4];
uniform float u_foam_height;
uniform float u_foam_curve_factor;

attribute vec4 a_position;
attribute vec4 a_color0;

varying vec4 v_color0;
varying float rel_height;

void main()
{
  vec4 posW = a_position * u_m;
   
  float c_avg[5];
  c_avg[0] = 1.0; c_avg[1] = 1.0; c_avg[2] = 0.5; c_avg[3] = 0.33; c_avg[4] = 0.25;
  
    float distArray[4];
  distArray[0] = length(posW.xz - u_foam_pos[0].xz);
  distArray[1] = length(posW.xz - u_foam_pos[1].xz);
  distArray[2] = length(posW.xz - u_foam_pos[2].xz);
  distArray[3] = length(posW.xz - u_foam_pos[3].xz);
  
  float avg_count = 0.0;   
  rel_height = 0.0;
  for(int i=0;i<4;++i)
  {      
    float dist      = distArray[i];   
    float maxHeight = u_foam_curve_factor * dist * dist + u_foam_height;
    if(maxHeight > 0.0)  
    {
      rel_height       += 1.0 - clamp(posW.y / maxHeight, 0.0, 1.0);
      avg_count       += 1.0;
    }
  }
    
  if(avg_count > 0.0)
  {
    // Average the height
    rel_height *= (1.0 / avg_count);
  }
    
  v_color0    = a_color0;
  gl_Position = a_position * u_mvp;
}